<?php

class mtg_go_templater
{
  function tpl_struct()
  {
    $TPL = <<<EOD
//package autogen
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!

%includes%

type %class% struct {
  %parent_class%
  %fields%
}

var _%class%_class_props map[string]string = %class_props%
var _%class%_class_fields []string = %fields_names%
var _%class%_fields_props meta.ClassFieldsProps = %fields_props%

func %class%_CLASS_ID() uint32 {
  return %class_id%
}

type I%class% interface {
  meta.IMetaStruct
  Ptr%class%() *%class%
}

func (*%class%) CLASS_ID() uint32 {
  return %class_id%
}

func (*%class%) CLASS_NAME() string {
  return "%class%"
}

func (*%class%) CLASS_PROPS() *map[string]string {
  return &_%class%_class_props
}

func (*%class%) CLASS_FIELDS() []string {
  return _%class%_class_fields
}

func (*%class%) CLASS_FIELDS_PROPS() *meta.ClassFieldsProps {
  return &_%class%_fields_props
}

//convenience getter
func Ptr%class%(m meta.IMetaStruct) *%class% {
  p, ok := m.(I%class%)
  if !ok {
    return nil
  }
  return p.Ptr%class%()
}

func (self *%class%) Ptr%class%() *%class% {
  return self
}

func New%class%() *%class% {
  item := new (%class%)
  item.Reset()
  return item
}

func (self *%class%) Reset() {
  %fields_reset%
}

func (self *%class%) Read(reader meta.Reader) error {
  return meta.ReadStruct(reader, self, "")
}

func (self *%class%) ReadFields(reader meta.Reader) error {
  self.Reset()
  %read_buffer%
  return nil
}

func (self *%class%) Write(writer meta.Writer) error {
  return meta.WriteStruct(writer, self, "")
}

func (self *%class%) WriteFields(writer meta.Writer) error {
  %write_buffer%
  return nil
}

%ext_methods%

%analytics_methods%

EOD;
    return $TPL;
  }

  function tpl_collection_item()
  {
    $TPL = <<<EOD

func (self *%class%) NewInstance() meta.IMetaDataItem {
  return New%class%()
}

func (self *%class%) GetDbTableName() string {
  return "%table_name%"
}

func (self *%class%) GetDbFields() []string {
  return self.CLASS_FIELDS()
}

func (self *%class%) GetOwnerFieldName() string {
  return "%owner%"
}

func (self *%class%) GetIdFieldName() string {
  return "%id_field_name%"
}

func (self *%class%) GetIdValue() uint64 {
  return uint64(self.%id_field%)
}

func (self *%class%) Import(data interface{}) {
  switch data.(type) {
    case %class%:
    {
      %import_from_mysql%
      break
    }
    default:
      break
  }
}

func (self *%class%) Export(data []interface{}) {
  %export_to_arr%
}

EOD;
    return $TPL;
  }

  function tpl_enum()
  {
    $TPL = <<<EOD
//package autogen
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!

const (%consts%)

type %class% int32

var _%class%_values []int = []int{%values_list%}
var _%class%_map map[string]%class% = map[string]%class%{%values_map%}

func (*%class%) CLASS_ID() uint32 {
  return %class_id%
}

func (*%class%) CLASS_NAME() string {
  return "%class%"
}

func (*%class%) DEFAULT_VALUE() int32 {
  return %default_enum_value%
}

func (self *%class%) IsValid() bool {
  return sort.SearchInts(_%class%_values, int(*self)) != -1
}

func %class%_GetNameByValue(value int) string {
	for name, num := range _%class%_map {
		if value == int(num) {
			return name
		}
	}

	return ""
}

func New%class%ByName(name string) (%class%, error) {
  if v, ok := _%class%_map[name]; ok == true {
    return v, nil
  }
  return 0, errors.Errorf("Wrong name of %class%: '%s'", name)
}

EOD;
    return $TPL;
  }

  function tpl_packet()
  {
    $TPL = <<<EOD
//package autogen
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!

%includes%

type %class% struct {
  %parent_class%
  %fields%
}

var _%class%_class_props map[string]string = %class_props%
var _%class%_class_fields []string = %fields_names%
var %class%_ func(interface{}, *%class%, *%class_invert%) error
var _%class%_fields_props meta.ClassFieldsProps = nil

type I%class% interface {
  meta.IMetaStruct
  I%class%() *%class%
}

func (*%class%) CLASS_ID() uint32 {
  return %class_id%
}

func (*%class%) CLASS_NAME() string {
  return "%class%"
}

func (*%class%) CLASS_FIELDS_PROPS() *meta.ClassFieldsProps {
  return &_%class%_fields_props
}

func (*%class%) CLASS_PROPS() *map[string]string {
  return &_%class%_class_props
}

func (*%class%) CLASS_FIELDS() []string {
  return _%class%_class_fields
}

func (self *%class%) I%class%() *%class% {
  return self
}

func (*%class%) GetCode() int32 {
  return %code%
}

func New%class%() *%class% {
  item := new (%class%)
  item.Reset()
  return item
}

func (self *%class%) Reset() {
  %fields_reset%
}

func (self *%class%) Read(reader meta.Reader) error {
  return meta.ReadStruct(reader, self, "")
}

func (self *%class%) ReadFields(reader meta.Reader) error {
  self.Reset()
  %read_buffer%
  return nil
}

func (self *%class%) Write(writer meta.Writer) error {
  return meta.WriteStruct(writer, self, "")
}

func (self *%class%) WriteFields(writer meta.Writer) error {
  %write_buffer%
  return nil
}

EOD;
    return $TPL;
  }

  function tpl_bundle()
  {
    $TPL = <<<EOD
package autogen
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!
%bundle%

import (
  "fmt"
  "sort"
  "github.com/bit.games/meta"
  "github.com/bit.games/errors"
)

//supress *imported but not used* warnings
var _ = fmt.Printf
var _ = sort.SearchInts

// Common interfaces and types

%units_src%

func CreateById(classId uint32) (meta.IMetaStruct, error) {
  switch classId {
    %create_struct_by_crc28%
    default : return nil, errors.Errorf("Can't find struct for class id %d", classId)
  }
}

func CreateByName(name string) (meta.IMetaStruct, error) {
  switch name {
    %create_struct_by_name%
    default : return nil, errors.Errorf("Can't find struct for name %s", name)
  }
}

func CreateRPC(code uint32)(meta.IRPC, error) {
  switch code {
%create_rpc_by_code%
    default: return nil, errors.Errorf("Can't find rpc for code %d", code)
  }
}

EOD;

    return $TPL;
  }
  function tpl_rpc()
  {
    $TPL = <<<EOD
func New%rpc_name%() *%rpc_name% {
  rpc := %rpc_name%{}
  rpc.Req = New%rpc_req_name%()
  rpc.Rsp = New%rpc_rsp_name%()
  return &rpc
}

type %rpc_name% struct {
  ErrCode  int32
  ErrMsg string
  Req  *%rpc_req_name%
  Rsp *%rpc_rsp_name%
}

func (rpc *%rpc_name%) SetError(code int32, msg string) {
  rpc.ErrCode = code
  rpc.ErrMsg = msg
}

func (rpc *%rpc_name%) GetError() (int32, string) {
  return rpc.ErrCode, rpc.ErrMsg
}

func (rpc *%rpc_name%) GetRequest() meta.IMetaStruct {
  return rpc.Req
}

func (rpc *%rpc_name%) GetResponse() meta.IMetaStruct {
  return rpc.Rsp
}

func (rpc *%rpc_name%) GetName() string {
  return "%rpc_name%"
}

func (rpc *%rpc_name%) GetCode() int32 {
  return %code%
}

type IRPCHandler_%rpc_name% interface {
  %rpc_name%(*%rpc_name%) error
}

func (rpc *%rpc_name%) Execute(h interface{}) error{
  mh, ok := h.(IRPCHandler_%rpc_name%)
  if !ok {
    return errors.New("RPC '%rpc_name%(*%rpc_name%) error' is not implemented")
  }
  return mh.%rpc_name%(rpc)
}

EOD;
    return $TPL;
  }
}
